/** @file HL_sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com  
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
#include "HL_mibspi.h"
/* USER CODE END */

/* Include Files */

#include "HL_sys_common.h"

/* USER CODE BEGIN (1) */
#define D_COUNT 1
#define RXINTFLG (1 << 8)
#define FOUR_DATA_LINE_MODE 0x2

//uint16 tx_ctrl[D_COUNT] = {0x803E};
uint16 tx_data[D_COUNT] = {0xC3A5};
uint16 rx_data[D_COUNT] = {0};
uint16 group=0;

struct Master_Bits
{
    unsigned char Bit15 : 1;
    unsigned char Bit14 : 1;
    unsigned char Bit13 : 1;
    unsigned char Bit12 : 1;
    unsigned char Bit11 : 1;
    unsigned char Bit10 : 1;
    unsigned char Bit9 : 1;
    unsigned char Bit8 : 1;
    unsigned char Bit7 : 1;
    unsigned char Bit6 : 1;
    unsigned char Bit5 : 1;
    unsigned char Bit4 : 1;
    unsigned char Bit3 : 1;
    unsigned char Bit2 : 1;
    unsigned char Bit1 : 1;
    unsigned char Bit0 : 1;

};
union Master_Format
{
    unsigned short Master_Data;
    struct Master_Bits Bits;

};
struct Slave_Bits
{
    unsigned char Bit15 : 1;
    unsigned char Bit11 : 1;
    unsigned char Bit7 : 1;
    unsigned char Bit3 : 1;
    unsigned char Bit14 : 1;
    unsigned char Bit10 : 1;
    unsigned char Bit6 : 1;
    unsigned char Bit2 : 1;
    unsigned char Bit13 : 1;
    unsigned char Bit9 : 1;
    unsigned char Bit5 : 1;
    unsigned char Bit1 : 1;
    unsigned char Bit12 : 1;
    unsigned char Bit8 : 1;
    unsigned char Bit4 : 1;
    unsigned char Bit0 : 1;

};
union Slave_Format
{
    unsigned short Slave_Data;
    struct Slave_Bits Bits;

};
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
unsigned short Converting_Master_to_Slave_Format (unsigned short Data);
unsigned short Converting_Slave_to_Master_Format (unsigned short Data);
unsigned short Variable1, Variable2;
/* USER CODE END */

int main(void)
{
/* USER CODE BEGIN (3) */
//    mibspiInit();
//    mibspiREG5->PMCTRL  |=   (FOUR_DATA_LINE_MODE << 0);
//    mibspiSetData(mibspiREG5, group, tx_data);
//    mibspiTransfer(mibspiREG5, group);
//
//    while(!(mibspiREG5->FLG & RXINTFLG));
//    mibspiGetData(mibspiREG5, group, rx_data);
    Variable1 = 0xAA55;
    Variable2 = Converting_Master_to_Slave_Format(Variable1);
    Variable1 = 1234;
    Variable2 = Converting_Slave_to_Master_Format(Variable1);

    while(1)
    {
        ;
    }
/* USER CODE END */

    return 0;
}


/* USER CODE BEGIN (4) */
unsigned short Converting_Master_to_Slave_Format (unsigned short Data)
{
    union Master_Format Data1;
    union Slave_Format Data2;
    Data1.Master_Data = Data;

    Data2.Bits.Bit15 = Data1.Bits.Bit15;
    Data2.Bits.Bit14 = Data1.Bits.Bit14;
    Data2.Bits.Bit13 = Data1.Bits.Bit13;
    Data2.Bits.Bit12 = Data1.Bits.Bit12;
    Data2.Bits.Bit11 = Data1.Bits.Bit11;
    Data2.Bits.Bit10 = Data1.Bits.Bit10;
    Data2.Bits.Bit9 = Data1.Bits.Bit9;
    Data2.Bits.Bit8 = Data1.Bits.Bit8;
    Data2.Bits.Bit7 = Data1.Bits.Bit7;
    Data2.Bits.Bit6 = Data1.Bits.Bit6;
    Data2.Bits.Bit5 = Data1.Bits.Bit5;
    Data2.Bits.Bit4 = Data1.Bits.Bit4;
    Data2.Bits.Bit3 = Data1.Bits.Bit3;
    Data2.Bits.Bit2 = Data1.Bits.Bit2;
    Data2.Bits.Bit1 = Data1.Bits.Bit1;
    Data2.Bits.Bit0 = Data1.Bits.Bit0;

    return Data2.Slave_Data;
}

unsigned short Converting_Slave_to_Master_Format (unsigned short Data)
{
    union Slave_Format Data1;
    union Master_Format Data2;
    Data1.Slave_Data = Data;

    Data2.Bits.Bit15 = Data1.Bits.Bit15;
    Data2.Bits.Bit14 = Data1.Bits.Bit14;
    Data2.Bits.Bit13 = Data1.Bits.Bit13;
    Data2.Bits.Bit12 = Data1.Bits.Bit12;
    Data2.Bits.Bit11 = Data1.Bits.Bit11;
    Data2.Bits.Bit10 = Data1.Bits.Bit10;
    Data2.Bits.Bit9 = Data1.Bits.Bit9;
    Data2.Bits.Bit8 = Data1.Bits.Bit8;
    Data2.Bits.Bit7 = Data1.Bits.Bit7;
    Data2.Bits.Bit6 = Data1.Bits.Bit6;
    Data2.Bits.Bit5 = Data1.Bits.Bit5;
    Data2.Bits.Bit4 = Data1.Bits.Bit4;
    Data2.Bits.Bit3 = Data1.Bits.Bit3;
    Data2.Bits.Bit2 = Data1.Bits.Bit2;
    Data2.Bits.Bit1 = Data1.Bits.Bit1;
    Data2.Bits.Bit0 = Data1.Bits.Bit0;

    return Data2.Master_Data;
}
/* USER CODE END */
